
                               ;-----------------------------------------------------------------------
                               ;copper bars, without framebuffer writes !
                               ;many code credits to Duke & Wire of Napalm , kvaks
                               ;by Vzzrzzf (June 19, 2001)
                               ;PAL/NTSC version
                               ;
                               ;only worthwhile thing is how i gain a horizontal retrace one-shot timer
                               ;and syscall for vertical retrace falling edge
                               ;there is more code you might useful
                               ;the rest is just for fun.
                               ;
                               ;224 scanlines per interlaced frame gives
                               ;us a 1x224 screen! (with lazy vertical pixel doubling)
                               ;-----------------------------------------------------------------------



                               MESSAGE     "PS2 Copper Bars ~demo~ (yeah right) for ASM5900 v1.8b"
                               TARGET      BIN, R5900


                               INCLUDE     "..\ps2lib\equates.inc"
                               INCLUDE     "..\ps2lib\macros.inc"
                               INCLUDE     "..\ps2lib\syscalls.inc"
                               INCLUDE     "..\ps2lib\elfhead.inc"



                               ALIGN$$     16
code                           SEGMENT     400000h

                               INCLUDE     "..\ps2lib\dma.inc"
                               INCLUDE     "..\ps2lib\gif.inc"
                               INCLUDE     "..\ps2lib\gs.inc"



; ------------------------------------------------------------
; Horizontal Retrace interrupt
; note that there is no "install handler" function because the
; one-shot interrupt is set up in the call to Wait_int_HR
; ------------------------------------------------------------

; for illustrative purposes, global data is kept with the code
HRflag                         DW          0

HRhandler                      PROC
                               la          t0, HRflag
                               addiu       at, zero, 1
                               sw          at, 0(t0)

                               daddu       v0, zero, zero
                               daddu       v1, zero, zero

                               jr          ra
                               nop
HRhandler                      ENDP

; void Wait_int_HR(int num_hsyncs);
Wait_int_HR                    PROC
                                                                               ; attach the HR interrupt handler (one-shot)
                               di
                             ; addiu a0, zero, 1
                                                                               ; a0 set by argument to function
                               la          a1, HRhandler
                               ori         a2, zero, 0
                               addiu       v1, zero, 24
                               syscall
                               nop

                               la          v0, HRflag
                               sw          zero, 0(v0)
                               ei

                                                                               ; we set HRflag = 0
                                                                               ; now we wait for it to become nonzero (from HRhandler)
  lp:
                               lw          v1, 0(v0)
                               nop
                               beq         v1, zero, lp
                               nop

                               jr          ra
                               nop
Wait_int_HR                    ENDP

; -------------

; this was Duke's method in 3stars, not used here though
; this polls the GS directly
WaitGSVR_start                 PROC
                               lui         v0, 1200h
  lp:
                               lw          v1, 1000h(v0)
                               andi        v1, v1, 8
                               beq         v1, zero, lp
                               nop

                               jr          ra
                               nop
WaitGSVR_start                 ENDP

; -------------

                                                                               ; end-of-Vertical-retrace interrupt handler
                                                                               ; (ie. interrupts when gun is on again)

VRendf                         DW          0
VRendid                        DW          0

install_VRend_handler          PROC
                               di

                                                                               ; install handler
                               addiu       a0, zero, 3
                               la          a1, VRend_handler
                               addiu       a2, zero, 0
                               addiu       v1, zero, 16
                               syscall
                               nop

                               la          a0, VRendid
                               sw          v0, 0(a0)

                                                                               ; enable it
                               addiu       a0, zero, 3
                               addiu       v1, zero, 20
                               syscall
                               nop

                               la          a0, VRendf
                               sw          zero, 0(a0)

                               ei

                               jr          ra
                               nop
install_VRend_handler          ENDP

; untested
remove_VRend_handler           PROC
                               di

                                                                               ; remove handler
                               la          v0, VRendid
                               lw          a1, 0(v0)
                               addiu       a0, zero, 3
                               addiu       v1, zero, 17
                               syscall
                               nop

                                                                               ; don't disable that class of interrupts because other handlers may be there

                               ei

                               jr          ra
                               nop
remove_VRend_handler           ENDP
; untested

VRend_handler                  PROC
                               la          v0, VRendf
                               addiu       v1, zero, 1
                               sw          v1, 0(v0)

                               daddu       v0, zero, zero
                               daddu       v1, zero, zero

                               jr          ra
                               nop
VRend_handler                  ENDP


WaitVR_end                     PROC
                               di
                               la          v0, VRendf
                               sw          zero, 0(v0)
                               ei

  lp:
                               lw          v1, 0(v0)
                               nop
                               beq         v1, zero, lp
                               nop

                               jr          ra
                               nop
WaitVR_end                     ENDP

; -------------

                                                                               ; start-of-Vertical-retrace interrupt handler
                                                                               ; (ie. interupts when gun turns off)

VRstartf                       DW          0
VRstartid                      DW          0

install_VRstart_handler        PROC
                               di

                                                                               ; install handler
                               addiu       a0, zero, 2
                               la          a1, VRstart_handler
                               addiu       a2, zero, 0
                               addiu       v1, zero, 16
                               syscall
                               nop

                               la          a0, VRstartid
                               sw          v0, 0(a0)

                                                                               ; enable it
                               addiu       a0, zero, 2
                               addiu       v1, zero, 20
                               syscall
                               nop

                               la          a0, VRstartf
                               sw          zero, 0(a0)

                               ei

                               jr          ra
                               nop
install_VRstart_handler        ENDP

; untested
remove_VRstart_handler         PROC
                               di

                                                                               ; remove handler
                               la          v0, VRstartid
                               lw          a1, 0(v0)
                               addiu       a0, zero, 2
                               addiu       v1, zero, 17
                               syscall
                               nop

                                                                               ; don't disable that class of interrupts because other handlers may be there

                               ei

                               jr          ra
                               nop
remove_VRstart_handler         ENDP
; untested

VRstart_handler                PROC
                               la          v0, VRstartf
                               addiu       v1, zero, 1
                               sw          v1, 0(v0)

                               daddu       v0, zero, zero
                               daddu       v1, zero, zero

                               jr          ra
                               nop
VRstart_handler                ENDP

WaitVR_start                   PROC
                               di
                               la          v0, VRstartf
                               sw          zero, 0(v0)
                               ei
  lp:
                               lw          v1, 0(v0)
                               nop
                               beq         v1, zero, lp
                               nop

                               jr          ra
                               nop
WaitVR_start                   ENDP

; -------------

                                                                               ; waitHR based on timer0

WaitHRtmr0                     PROC
                               di
                               lui         v0, 1000h
                               sw          zero, 10h(v0)                       ; mode
                               sw          zero, 0(v0)                         ; count
                               ori         v1, zero, 083h
                               sw          v1, 10h(v0)
                               ei

  lp:
                               lw          v1, 0(v0)
                               nop
                               beq         v1, zero, lp
                               nop

                               sw          zero, 10h(v0)

                               jr          ra
                               nop
WaitHRtmr0                     ENDP

; -------------






; utility functions

; -------------

; bounds(x, p, q) => return (p <= x && x <= q)
bounds                         PROC
                                                                               ; forcibly sign-extend x, p, and q to 64-bits
                               dsll32      a0, a0, 0
                               dsll32      a1, a1, 0
                               dsll32      a2, a2, 0
                               dsra32      a0, a0, 0
                               dsra32      a1, a1, 0
                               dsra32      a2, a2, 0

                               daddu       v0, zero, zero

                               slt         a1, a1, a0
                               slt         a2, a0, a2
                               and         v0, a1, a2

                               jr          ra
                               nop
bounds                         ENDP

; -------------


                               ALIGN       8
main                           PROC
                               ei

                               jal         GsDetectMode
                               addiu       a0, zero, NON_INTERLACED
                               addiu       a2, zero, FRAME
                               jal         GsInit
                               move        a1, v0

                               lui         v1, 1200h                           ; disable framebuffer output ... what am i up to ?
                               daddu       v0, zero, zero
                               ori         v0, zero, 0ff60h
                               sd          v0, 0(v1)
                               ori         v0, zero, 03h
                               sd          v0, 020h(v1)

                               jal         install_VRend_handler
                               nop

                                                                               ; init complete


  lp:
                               ori         s0, zero, 0

  setline:
                                                                               ; addiu a0, zero, 1
                                                                               ; jal Wait_int_HR
                                                                               ; nop
                               jal         WaitHRtmr0
                               nop

                               lui         t0, 1200h
                               sw          s7, 0e0h(t0)                        ; set color

                               la          s3, cubars
                               addiu       s7, zero, 0                         ; black background

  decidecolor:

                                                                               ; is it the terminator ?
                               lw          s5, 0(s3)
                               lw          s6, 4(s3)
                               bltz        s5, color_decided
                               nop

                               or          a0, s0, zero                        ; current scanline
                               or          a1, s5, zero                        ; y1
                               or          a2, s6, zero                        ; y2
                               jal         bounds
                               nop

                               bne         v0, zero, assncolor
                               nop

                               addiu       s3, s3, 16

                               j           decidecolor
                               nop

  assncolor:

                               lw          s7, 8(s3)
                               nop
                                                                               ; take exponential ratio based on distance from center
                               sub         t1, s6, s5                          ; y2 - y1
                               srl         t1, t1, 1                           ; (y2 - y1) / 2
                               add         t1, t1, s5
                               sub         t1, s0, t1                          ; difference between current line and bar's center
                               sra         t3, t1, 31
                               xor         t1, t1, t3
                               sub         t1, t1, t3
                               srl         t1, t1, 1
                                                                               ; use this as shift amount


                               andi        t3, s7, 000ffh                      ; red
                               andi        t4, s7, 0ff00h                      ; green
                               lui         t6, 0000ffh
                               and         t5, t6, s7                          ; blue
                               srlv        t3, t3, t1
                               srlv        t4, t4, t1
                               srlv        t5, t5, t1
                               andi        t3, t3, 000ffh
                               andi        t4, t4, 0ff00h
                               and         t5, t5, t6
                               or          s7, t3, t4
                               or          s7, s7, t5

                                                                               ; adjusted color complete !

  color_decided:
                                                                               ; now just wait until next round to set it

                               addiu       s0, s0, 1
                               addiu       s1, zero, 224
                               bne         s0, s1, setline
                               nop

                               lui         t0, 1200h
                               sw          zero, 0e0h(t0)


                                                                               ; done drawing this frame, decide how to move the bars

                               la          s3, cubars

  update_nextbar:

                                                                               ; is it the terminator ?
                               lw          s5, 0(s3)
                               lw          s6, 4(s3)
                               nop
                               bltz        s5, done_updating_barpos
                               nop

                                                                               ; is direction down or up
                               lw          s1, 12(s3)
                               nop
                               bne         s1, zero, dirdown
                               nop

  dirup:

                               addiu       s1, s5, -1
                               slt         s2, s1, zero
                               beq         s2, zero, decr_regular
                               nop

                               addiu       s5, s5, 1
                               addiu       s6, s6, 1
                               addiu       s2, zero, 1
                               sw          s5, 0(s3)
                               sw          s6, 4(s3)
                               sw          s2, 12(s3)

                               j           next_update_loop
                               nop

  decr_regular:

                               addiu       s5, s5, -1
                               addiu       s6, s6, -1
                               sw          s5, 0(s3)
                               sw          s6, 4(s3)

                               j           next_update_loop
                               nop

  dirdown:

                               addiu       s1, s6, 1
                               addiu       s4, zero, 224
                               slt         s2, s4, s1
                               beq         s2, zero, incr_regular
                               nop

                               addiu       s5, s5, -1
                               addiu       s6, s6, -1
                               addiu       s2, zero, 0
                               sw          s5, 0(s3)
                               sw          s6, 4(s3)
                               sw          s2, 12(s3)

                               j           next_update_loop
                               nop

  incr_regular:

                               addiu       s5, s5, 1
                               addiu       s6, s6, 1
                               sw          s5, 0(s3)
                               sw          s6, 4(s3)

                               j           next_update_loop
                               nop

  next_update_loop:

                               addiu       s3, s3, 16

                               j           update_nextbar
                               nop

  done_updating_barpos:

                               jal         WaitVR_end
                               nop

                               j           lp
                               nop

main                           ENDP


; data area
                               ALIGN       8

; type bar {y1, y2, color, dir}
; dir: 0 = up, 1 = down

; bar cubars[NUMBARS]

cubars:
                               DW          0, 10, 0007fffh, 0                  ; bar 1
                               DW          20, 30, 000ff00h, 0                 ; bar 2
                               DW          40, 50, 0ff0000h, 0                 ; bar 3
                               DW          60, 70, 00000ffh, 0                 ; bar 4
                               DW          80, 90, 07f7f00h, 0                 ; bar 5
                               DW          100, 110, 07f007fh, 0               ; bar 6
                               DW          120, 130, 07f7f7fh, 0               ; bar 7
                               DW          140, 150, 0bacc3fh, 0               ; bar 8
                               DW          160, 170, 03fccbah, 0               ; bar 9
                               DW          0ffffffffh, 0ffffffffh, 0, 0        ; list terminator


code                           ENDS
                               END
